uniform float alpha;
uniform sampler2D Texture;
uniform sampler2DShadow ShadowMap;
uniform int TexOn;
uniform int ShadowOn;

float lookup()
{
	// clamp the shadowmap projection to forward only
	float z = gl_TexCoord[1].z / gl_TexCoord[1].w;
	float c = step(0.6, z) * step(z, 1.0);

    float depth = shadow2DProj(ShadowMap, gl_TexCoord[1]).r * c;
	return depth != 1.0 ? 0.75 : 1.0;
}

void main()
{
	float shadeFactor = 1.0;
	
	if (ShadowOn == 1)
	{
		shadeFactor = lookup();
	}
		
	vec4 texels = texture2D(Texture, vec2(gl_TexCoord[0]));
    
	if (TexOn == 1)
		gl_FragColor = vec4(shadeFactor * gl_Color.rgb, alpha) * texels;
	else
		gl_FragColor = vec4(shadeFactor * gl_Color.rgb, alpha);
}